package com.fr.plugin.llcassso.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "单点登录配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.fr.plugin.llcassso.config", text = "单点登录配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "ticket", name = "请求ticket地址", description = "请求ticket地址", status = Status.SHOW)
    private Conf<String> ticket = Holders.simple("http://xxx/login");

    @Identifier(value = "validate", name = "验证ticket地址", description = "验证ticket地址", status = Status.SHOW)
    private Conf<String> validate = Holders.simple("http://xxx/validate");

    public String getTicket() {
        return ticket.get();
    }

    public void setTicket(String url) {
        this.ticket.set(url);
    }

    public String getValidate() {
        return validate.get();
    }

    public void setValidate(String url) {
        this.validate.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
